/* AMX Mod script.
*
* AMXX DoD Missing Sounds
*  by Trp. Jed (jed@wunderboy.org)
*
* Re-instates some of the "missing" voice commands from earlier
* versions of DoD. Autodetects if player if allies or axis and
* plays correct language. cvar sets which allied voice to use.
*
* Settings:
*  amx_dodmissingsounds 0/1 - enable the missing sounds (put in server.cfg)
*  amx_britishmap 0/1 - sets whether to use British or American voices (put in map.cfg)
* 
* Usage:
*  Bind a key to one of the following commands:
*
*  voice_coverflanks
*  voice_defendobjective	(British only)
*  voice_defendposition		(British only)
*  voice_dropguns
*  voice_firmleft
*  voice_firmright
*  voice_medic
*  voice_moveout
*  voice_moveuppiat		(British only)
*  voice_prepare
*  voice_spreadout
*  voice_tankahead
*  voice_takecover
*  voice_takeflank
*  voice_takeobjective		(British only)
*
*
* Example:
*  bind "o" "voice_medic"
* 
*
* This file is provided as is (no warranties).
*
*/


#include <amxmodx>
#include <amxmisc>
#include <fun> 

new Float:g_Flooding[33]	// used to stop people spamming the commands
new Float:maxChat = 1.00
new is_brit = 0			// holds if player is british or not

// pre-cache the sounds
//
public plugin_precache() { 
	precache_sound( "player/britmedic.wav" )
	precache_sound( "player/uscoverflanks.wav" )
	precache_sound( "player/britcoverflanks.wav" )
	precache_sound( "player/gercoverflanks.wav" )
	precache_sound( "player/britdefendobj.wav" )
	precache_sound( "player/britdefendarea.wav" )
	precache_sound( "player/usdropguns.wav" )
	precache_sound( "player/britdropguns.wav" )
	precache_sound( "player/gerdropguns.wav" )
	precache_sound( "player/usleft.wav" )
	precache_sound( "player/britleft.wav" )
	precache_sound( "player/germanleft.wav" )
	precache_sound( "player/usright.wav" )
	precache_sound( "player/britright.wav" )
	precache_sound( "player/germanright.wav" )
	precache_sound( "player/usmedic.wav" )
	precache_sound( "player/britmedic.wav" )
	precache_sound( "player/germedic.wav" )
	precache_sound( "player/usmoveout.wav" )
	precache_sound( "player/germoveout.wav" )
	precache_sound( "player/britbringuppiat.wav" )
	precache_sound( "player/usprepare.wav" )
	precache_sound( "player/britprepare.wav" )
	precache_sound( "player/gerprepare.wav" )
	precache_sound( "player/usspreadout.wav" )
	precache_sound( "player/britspeadout.wav" )
	precache_sound( "player/gerspreadout.wav" )
	precache_sound( "player/ustigerahead.wav" )
	precache_sound( "player/brittigerahead.wav" )
	precache_sound( "player/gertankahead.wav" )
	precache_sound( "player/ustakecover.wav" )
	precache_sound( "player/brittakecover.wav" )
	precache_sound( "player/gertakecover.wav" )
	precache_sound( "player/usflank.wav" )
	precache_sound( "player/britflank.wav" )
	precache_sound( "player/gerflank.wav" )
	precache_sound( "player/brittakeobj.wav" )
}

// plugin-initialisation
//
public plugin_init() { 
   register_plugin("AMXX DoD Missing Sounds","1.0","Neil 'Jed' Jedrzejewski") 
   register_cvar("amx_dodmissingsounds","0")
   register_clcmd("voice_coverflanks","dodvoice_cflanks")
   register_clcmd("voice_defendobjective","dodvoice_defobj")
   register_clcmd("voice_defendposition","dodvoice_defpos")
   register_clcmd("voice_dropguns","dodvoice_dropguns")
   register_clcmd("voice_firmleft","dodvoice_firmleft")
   register_clcmd("voice_firmright","dodvoice_firmright")
   register_clcmd("voice_medic","dodvoice_medic")
   register_clcmd("voice_moveout","dodvoice_moveout")
   register_clcmd("voice_moveuppiat","dodvoice_moveuppiat")
   register_clcmd("voice_prepare","dodvoice_prepare")
   register_clcmd("voice_spreadout","dodvoice_spreadout")
   register_clcmd("voice_tankahead","dodvoice_tankahead")
   register_clcmd("voice_takecover","dodvoice_takecover")
   register_clcmd("voice_takeflank","dodvoice_takeflank")
   register_clcmd("voice_takeobjective","dodvoice_takeobj")
   return PLUGIN_CONTINUE 
}  

// -------------------------------------------------------

// voice_coverflanks (all teams)
//
public dodvoice_cflanks(id) {
	new cTeam[16]
	get_user_info(id,"team",cTeam,15)

	if ( can_play(id) )
	{
		if (equal(cTeam, "allies")) {
			if (is_brit == 1) {
				emit_sound(id,CHAN_VOICE, "player/britcoverflanks.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			} else {
				emit_sound(id,CHAN_VOICE, "player/uscoverflanks.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			}
		} else {
			emit_sound(id,CHAN_VOICE, "player/gercoverflanks.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		}
		client_cmd(id,"say_team Cover the flanks!")
	}
	return PLUGIN_HANDLED 
}

// voice_defendobjective (british only)
//
public dodvoice_defobj(id) {
	new cTeam[16]
	get_user_info(id,"team",cTeam,15)

	if ( can_play(id) )
	{
		if (equal(cTeam, "allies")) {
			if (is_brit == 1) {
				emit_sound(id,CHAN_VOICE, "player/britdefendobj.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
				client_cmd(id,"say_team Defend this objective!")
			}
		}
		
	}
	return PLUGIN_HANDLED 
}

// voice_defendposition (british only)
//
public dodvoice_defpos(id) {
	new cTeam[16]
	get_user_info(id,"team",cTeam,15)
	
	if ( can_play(id) )
	{
		if (equal(cTeam, "allies")) {
			if (is_brit == 1) {
				emit_sound(id,CHAN_VOICE, "player/britdefendarea.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
				client_cmd(id,"say_team Defend this position!")
			}
		}
		
	}
	return PLUGIN_HANDLED 
}

// voice_dropguns (all teams)
//
public dodvoice_dropguns(id) {
	new cTeam[16]
	get_user_info(id,"team",cTeam,15)
	
	if ( can_play(id) )
	{
		if (equal(cTeam, "allies")) {
			if (is_brit == 1) {
				emit_sound(id,CHAN_VOICE, "player/britdropguns.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			} else {
				emit_sound(id,CHAN_VOICE, "player/usdropguns.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			}
		} else {
			emit_sound(id,CHAN_VOICE, "player/gerdropguns.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		}
		client_cmd(id,"say_team Drop your weapons!")
	}
	return PLUGIN_HANDLED 
}

// voice_firmleft (all teams)
//
public dodvoice_firmleft(id) {
	new cTeam[16]
	get_user_info(id,"team",cTeam,15)
	
	if ( can_play(id) )
	{
		if (equal(cTeam, "allies")) {
			if (is_brit == 1) {
				emit_sound(id,CHAN_VOICE, "player/britleft.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			} else {
				emit_sound(id,CHAN_VOICE, "player/usleft.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			}
		} else {
			emit_sound(id,CHAN_VOICE, "player/germanleft.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		}
		client_cmd(id,"say_team Left!")
	}
	return PLUGIN_HANDLED 
}

// voice_firmright (all teams)
//
public dodvoice_firmright(id) {
	new cTeam[16]
	get_user_info(id,"team",cTeam,15)
	
	if ( can_play(id) )
	{
		if (equal(cTeam, "allies")) {
			if (is_brit == 1) {
				emit_sound(id,CHAN_VOICE, "player/britright.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			} else {
				emit_sound(id,CHAN_VOICE, "player/usright.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			}
		} else {
			emit_sound(id,CHAN_VOICE, "player/germanright.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		}
		client_cmd(id,"say_team Right!")
	}
	return PLUGIN_HANDLED 
}


// voice_medic (all teams)
//
public dodvoice_medic(id) {
	new cTeam[16]
	get_user_info(id,"team",cTeam,15)
	
	if ( can_play(id) )
	{
		if (equal(cTeam, "allies")) {
			if (is_brit == 1) {
				emit_sound(id,CHAN_VOICE, "player/britmedic.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			} else {
				emit_sound(id,CHAN_VOICE, "player/usmedic.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			}
		} else {
			emit_sound(id,CHAN_VOICE, "player/germedic.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		}
		client_cmd(id,"say_team Medic!")
	}
	return PLUGIN_HANDLED 
}

// voice_moveout (all teams)
//
public dodvoice_moveout(id) {
	new cTeam[16]
	get_user_info(id,"team",cTeam,15)
	
	if ( can_play(id) )
	{
		if (equal(cTeam, "allies")) {
			if (is_brit == 1) {
				emit_sound(id,CHAN_VOICE, "player/britgogogo.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			} else {
				emit_sound(id,CHAN_VOICE, "player/usmoveout.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			}
		} else {
			emit_sound(id,CHAN_VOICE, "player/germoveout.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		}
		client_cmd(id,"say_team Move out!")
	}
	return PLUGIN_HANDLED 
}

// voice_moveuppiat (british only)
//
public dodvoice_moveuppiat(id) {
	new cTeam[16]
	get_user_info(id,"team",cTeam,15)
	
	if ( can_play(id) )
	{
		if (equal(cTeam, "allies")) {
			if (is_brit == 1) {
				emit_sound(id,CHAN_VOICE, "player/britbringuppiat.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
				client_cmd(id,"say_team Move up the PIAT!")
			}
		}
		
	}
	return PLUGIN_HANDLED 
}

// voice_prepare (all teams)
//
public dodvoice_prepare(id) {
	new cTeam[16]
	get_user_info(id,"team",cTeam,15)
	
	if ( can_play(id) )
	{
		if (equal(cTeam, "allies")) {
			if (is_brit == 1) {
				emit_sound(id,CHAN_VOICE, "player/britprepare.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			} else {
				emit_sound(id,CHAN_VOICE, "player/usprepare.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			}
		} else {
			emit_sound(id,CHAN_VOICE, "player/gerprepare.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		}
		client_cmd(id,"say_team Prepare to attack!")
	}
	return PLUGIN_HANDLED 
}

// voice_spreadout (all teams)
//
public dodvoice_spreadout(id) {
	new cTeam[16]
	get_user_info(id,"team",cTeam,15)
	
	if ( can_play(id) )
	{
		if (equal(cTeam, "allies")) {
			if (is_brit == 1) {
				emit_sound(id,CHAN_VOICE, "player/britspeadout.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)	// yes the typo is intentional!!!
			} else {
				emit_sound(id,CHAN_VOICE, "player/usspreadout.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			}
		} else {
			emit_sound(id,CHAN_VOICE, "player/gerspreadout.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		}
		client_cmd(id,"say_team Spread out!")
	}
	return PLUGIN_HANDLED 
}

// voice_tankahead (all teams)
//
public dodvoice_tankahead(id) {
	new cTeam[16]
	get_user_info(id,"team",cTeam,15)
	
	if ( can_play(id) )
	{
		if (equal(cTeam, "allies")) {
			if (is_brit == 1) {
				emit_sound(id,CHAN_VOICE, "player/brittigerahead.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			} else {
				emit_sound(id,CHAN_VOICE, "player/ustigerahead.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			}
		} else {
			emit_sound(id,CHAN_VOICE, "player/gertankahead.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		}
		client_cmd(id,"say_team Tank ahead!")
	}
	return PLUGIN_HANDLED 
}


// voice_takecover (all teams)
//
public dodvoice_takecover(id) {
	new cTeam[16]
	get_user_info(id,"team",cTeam,15)
	
	if ( can_play(id) )
	{
		if (equal(cTeam, "allies")) {
			if (is_brit == 1) {
				emit_sound(id,CHAN_VOICE, "player/brittakecover.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			} else {
				emit_sound(id,CHAN_VOICE, "player/ustakecover.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			}
		} else {
			emit_sound(id,CHAN_VOICE, "player/gertakecover.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		}
		client_cmd(id,"say_team Take Cover!")
	}
	return PLUGIN_HANDLED 
}

// voice_takeflank (all teams)
//
public dodvoice_takeflank(id) {
	new cTeam[16]
	get_user_info(id,"team",cTeam,15)
	
	if ( can_play(id) )
	{
		if (equal(cTeam, "allies")) {
			if (is_brit == 1) {
				emit_sound(id,CHAN_VOICE, "player/britflank.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			} else {
				emit_sound(id,CHAN_VOICE, "player/usflank.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			}
		} else {
			emit_sound(id,CHAN_VOICE, "player/gerflank.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		}
		client_cmd(id,"say_team Take the flank!")
	}
	return PLUGIN_HANDLED 
}

// voice_takeobjective (british only)
//
public dodvoice_takeobj(id) {
	new cTeam[16]
	get_user_info(id,"team",cTeam,15)
	
	if ( can_play(id) )
	{
		if (equal(cTeam, "allies")) {
			if (is_brit == 1) {
				emit_sound(id,CHAN_VOICE, "player/brittakeobj.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
				client_cmd(id,"say_team Take the objective!")
			}
		}
		
	}
	return PLUGIN_HANDLED 
}


// -------------------------------------------------------
// sanity check if we should play the sound or not
//
public can_play(id) {
       	new cTeam[16]
      	new cModel[16]
	new Float:nexTime = get_gametime()
	
	// check for exessive spamming
	if ( g_Flooding[id] > nexTime )   
	{
	      g_Flooding[ id ] = nexTime + maxChat + 3.0
	      return 0
	}
	g_Flooding[id] = nexTime + maxChat

	// hack to get the player model and play the right sound for the allies
	get_user_info(id, "model", cModel, 15)
	if (equali(cModel, "brit-inf"))
	{
		is_brit = 1
	} else {
		is_brit = 0
	}	

	get_user_info(id, "team", cTeam, 15)
	if (is_user_connected(id) && is_user_alive(id) && !is_user_bot(id) && !is_user_hltv(id) && !equali(cTeam, "spectator") && get_cvar_num("amx_dodmissingsounds") == 1) {
		return 1
	}

	return 0
}